<?php
/**
 * եѴԤ
 */
class ImageConverter {
	var $outputImageDir;		// Ѵβ¸
	var $outputImageType;		// Ѵβη
	var $outputImageWidth;		// Ѵββ
	var $outputImageHeight;		// Ѵβι⤵
	var $outputImageFileSize;	// ѴβΥե륵

	// 󥹥ȥ饯
	function ImageConverter() {
		$this->outputImageDir    = realpath(realpath(dirname(__FILE__)));
		$this->outputImageType   = 'jpeg';
		$this->outputImageWidth  = 320;
		$this->outputImageHeight = NULL;
		$this->outputFileSize    = 20000;
	}

	// Ѵ¹
	function execute($inputImagePath) {
		// 
		$filestat         = @stat($inputImagePath);
		$imagesize        = getimagesize($inputImagePath);
		$inputImageWidth  = $imagesize[0];
		$inputImageHeight = $imagesize[1];
		$inputImageType   = $imagesize[2];
		$outputImageName  = sha1($inputImagePath . '_' . $this->outputImageWidth . '_' . $this->outputFileSize . '_' . $filestat['mtime']) . '.' . $this->outputImageType;
		$outputImagePath  = $this->outputImageDir . '/' . $outputImageName;

		// Ѵβι⤵ꤵƤʤ硢Ѵββ
		if (is_null($this->outputImageHeight)) {
			$this->outputImageHeight = $inputImageHeight * ($this->outputImageWidth / $inputImageWidth);
		}

		// ե뤬¸ߤ뤫ǧ¸ߤʤΤߺ
		if (file_exists($outputImagePath)) {
			$info['convert'] = FALSE;
		} else {
			// ե
			switch($inputImageType) {
			case 1:
				// gif
				$tempImage = imagecreatefromgif($inputImagePath);
				break;
			case 2:
				// jpeg
				$tempImage = imagecreatefromjpeg($inputImagePath);
				break;
			case 3:
				// png
				$tempImage = imagecreatefrompng($inputImagePath);
				break;
			case 6:
				// bmp
				$tempImage = imagecreatefromwbmp($inputImagePath);
				break;
			}

			if (!$tempImage) {
				return false;
			}

			$scale = 1.0;
			$outputImagePathTemp = $outputImagePath . '.tmp-' . rand();
			do {
				// ե
				$outputImage = ImageCreateTruecolor($this->outputImageWidth * $scale, $this->outputImageHeight * $scale);
				ImageCopyResampled($outputImage, $tempImage, 0, 0, 0, 0, $this->outputImageWidth * $scale, $this->outputImageHeight * $scale, $inputImageWidth, $inputImageHeight);

				// ե

				@unlink($outputImagePathTemp);

				switch ($this->outputImageType) {
				case 1:
				case 'gif':
					imagegif($outputImage, $outputImagePathTemp);
					break;
				default:
				case 2:
				case 'jpg':
				case 'jpeg':
					$quality = 75;
					// ɽǽʥե륵ʲˤʤޤǡ10%ĥƥĴ
					do {
						@unlink($outputImagePathTemp);
						imagejpeg($outputImage, $outputImagePathTemp, $quality);
						$quality -= 10;
						clearstatcache();
					} while (filesize($outputImagePathTemp) > $this->outputFileSize && $quality > 0);
					break;
				case 3:
				case 'png':
					imagepng($outputImage, $outputImagePathTemp);
					break;
				case 6:
				case 'bmp':
					imagewbmp($outputImage, $outputImagePathTemp);
					break;
				}

				// 곫
				imagedestroy($outputImage);

				$scale -= 0.1;
				clearstatcache();
			} while (filesize($outputImagePathTemp) > $this->outputFileSize && $scale >= 0.5);

			rename($outputImagePathTemp, $outputImagePath);

			// 곫
			imagedestroy($tempImage);

			$info['convert'] = TRUE;
		}

		$info['outputImagePath']  = $outputImagePath;
		$info['outputImageName']  = $outputImageName;
		return $info;

	}

	// Setter
	function setOutputDir($outputDir)   { $this->outputImageDir   = $outputDir;  }
	function setImageType($imageType)   { $this->outputImageType  = $imageType;  }
	function setImageWidth($imageWidth) { $this->outputImageWidth = $imageWidth; }
	function setFileSize($fileSize)     { $this->outputFileSize   = $fileSize;   }
	// function setImageHeight($imageHeight) { $this->outputImageHeight = $imageHeight; }

	// Getter
	function getOutputDir()   { return $this->outputDir;         }
	function getImageType()   { return $this->outputImageType;   }
	function getImageWidth()  { return $this->outputImageWidth;  }
	function getImageHeight() { return $this->outputImageHeight; }

	/*
	 * PrivateMethod
	 */
	function beforeExecute() {
	}
}
?>
